#version 330

in vec3 vs_position;
in vec3 vs_color;
in vec3 vertex_position_to_fragment;

uniform float transp;
uniform int transp_all;
uniform float current_x;
uniform float current_y;

out vec4 fs_color;

void main()
{	
	float opacity;
	float radius = 2;
	if (transp_all == 1) 
	{
		opacity = transp;
	} 
	else
	{
		float distance = sqrt((vertex_position_to_fragment.x - current_x)*(vertex_position_to_fragment.x - current_x) + (vertex_position_to_fragment.y - current_y)*(vertex_position_to_fragment.y - current_y));
		if ( distance > radius) {opacity = 0.0;} else {opacity = 1.0 - distance / radius;};
	}
	

	fs_color = vec4(vs_color, opacity);
}