#version 330

layout (location = 0) in vec3 vertex_position;
layout (location = 1) in vec3 vertex_color;

out vec3 vs_position;
out vec3 vs_color;
out vec3 vertex_position_to_fragment;


uniform mat4 ModelMatrix;  
uniform mat4 ViewMatrix; 
uniform mat4 ProjectionMatrix;
uniform float plane_x;
uniform float plane_y;
uniform float plane_z;
uniform float plane_w;

uniform vec4 clip_plane0;

void main()
{
	vertex_position_to_fragment = vertex_position;
	vs_position = vec4(ModelMatrix * vec4(vertex_position, 1.f)).xyz;
	vs_color = vertex_color;

	gl_Position = ProjectionMatrix * ViewMatrix * ModelMatrix * vec4(vertex_position, 1.f);

	vec4 vsPos = ModelMatrix * vec4(vertex_position,1.0f);
	gl_ClipDistance[0] = dot(clip_plane0, vsPos);
	
}

//----ooops, you are not supposed to be here, buddy :)